<?php
/**
 * Hunt Locator default admin entry point file
 * 
 * @package    OpenSourceTechnologies.Map Locator
 * @subpackage Components
 * @copyright	Copyright (c)2011 Open Source Technologies. All Rights Reserved.
 * @license		GNU/GPLv3
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Hello Hello Controller
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class MapLocatorControllerSitelocation extends MapLocatorController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
		JRequest::setVar( 'view', 'sitelocation' );
		$this->registerTask( 'unpublish',	'publish' );
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		JRequest::setVar( 'view', 'sitelocations' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
	
		$model = $this->getModel('sitelocations');

		if ($model->store($post)) {
			$msg = JText::_( 'Site Saved!' );
		} else {
			$msg = JText::_( 'Error Saving Greeting' );
		}


		// Check the table in so it can be edited.... we are done with it anyway
		$link = 'index.php?option=com_maplocator&controller=sitelocation';
		$this->setRedirect($link, $msg);
	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('sitelocations');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or More Sites Could not be Deleted' );
		} else {
			$msg = JText::_( 'Site(s) Deleted' );
		}

		$this->setRedirect( 'index.php?option=com_maplocator&controller=sitelocation', $msg );
	}

	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_maplocator&controller=sitelocation', $msg );
	}
	
	
	/**
	 * published or unpublished a record
	 * @return void
	 */	
	function publish()
	{
		// Check for request forgeries
		//JRequest::checkToken() or jexit( 'Invalid Token' );

		$model = $this->getModel('sitelocations');

		$this->setRedirect( 'index.php?option=com_maplocator&controller=sitelocation&view=sitelocation' );

		// Initialize variables
		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		$n			= count( $cid );

		if (empty( $cid )) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}

		JArrayHelper::toInteger( $cid );
		$cids = implode( ',', $cid );


		$query = 'UPDATE #__sitelocator'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '. $cids.'  )'
		;
		
		$query;
		
		$db->setQuery( $query );
		if (!$db->query()) {
			return JError::raiseWarning( 500, $db->getError() );
		}

		/////// update svg file
		$model->CreateSVGContent();
		//////////////////////
		$model->LoadCountrySVGContent();
		$model->LoadCitySVGContent();
		

		$this->setMessage( JText::sprintf( $publish ? 'Items published' : 'Items unpublished', $n ) );
	}	
	
	
	function getcountrystate()
  	{ 
 
     global $mainframe;
     $country_id=JRequest::getVar('country_id');
     $model = $this->getModel('sitelocations');
     $state = $model->getState($country_id);

     $return= "<option value='0'>".JText::_( '---Select States---' )."</option>";

     if(is_array($state)) {
        foreach ($state as $states) {
                 $return .="<option value='".$states->state_id."'>".JText::_($states->state_name)."</option>";
        }
      }
	
      echo $return;      
      $mainframe->close();
 
  }	
  
	function getstatecity()
  	{ 
 
     global $mainframe;
     $state_id=JRequest::getVar('state_id');
     $model = $this->getModel('sitelocations');
     $city = $model->getCity($state_id);
	 


     $return= "<option value='0'>".JText::_( '---Select City---' )."</option>";

     if(is_array($city)) {
        foreach ($city as $citys) {
                 $return .="<option value='".$citys->city_id."'>".JText::_($citys->city_name)."</option>";
				
        }
      }
	  
      echo $return;      
      $mainframe->close();
 
  }	
}