<?php
/**
 * Map Locator default admin entry point file
 * 
 * @package    OpenSourceTechnologies.Map Locator
 * @subpackage Components
 * @copyright	Copyright (c)2011 Open Source Technologies. All Rights Reserved.
 * @license		GNU/GPLv3
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');


/**
 * SiteLocations Model
 *
 * @package    OpenSourceTechnologies.MapLocator
 * @subpackage Components
 */

class MapLocatorModelSitelocations extends JModel
{

	/**
	 * Constructor that retrieves the ID from the request
	 *
	 * @access	public
	 * @return	void
	 */
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
	}

	/**
	 * Method to set the identifier
	 *
	 * @access	public
	 * @param	int identifier
	 * @return	void
	 */
	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
		$this->_statedata	= null;
		$this->_citydata	= null;
	}

	/**
	 * Method to get a category
	 * @return object with data
	 */
	function &getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__sitelocator '.
					'  WHERE id = '.$this->_id  ;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->id = 0;
			$this->_data->state_id = 0;
			$this->_data->country_id = null;
			$this->_data->city_id = null;
			$this->_data->address = null;
			$this->_data->zip = null;
			$this->_data->city_lat_lont_corner_top = null;
			$this->_data->city_lat_lont_corner_bottom = null;
			$this->_data->location_name = null;
			$this->_data->location_lat_long = null;
			$this->_data->location_url= null;	
			$this->_data->author = null;
			$this->_data->createdate = null;
			$this->_data->published = null;
		
		}
		return $this->_data;
	}
	
	
	function CountryData()
	{
		// Load the data
		if (empty( $this->_data )) {
		$query = ' SELECT country_id as county_id, country_name as county_name, data as county_data'
			. ' FROM #__country'
			.' ORDER BY country_id';
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObjectlist();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->county_id = null;
			$this->_data->county_name = null;
			$this->_data->county_data = null;
	
		}
		return $this->_data;
	}	
	
	function StateData()
	{
		// Load the data
		if (empty( $this->_statedata )) {
		$query = ' SELECT state_id as st_id, state_name as st_name, data as st_data, clip_part as clip_data '
			. ' FROM #__state'
			.' ORDER BY state_id';
			$this->_db->setQuery( $query );
			$this->_statedata = $this->_db->loadObjectlist();
		}
		if (!$this->_statedata) {
			$this->_statedata = new stdClass();
			$this->_statedata->st_id = null;
			$this->_statedata->st_name = null;
			$this->_statedata->st_data = null;
			$this->_statedata->clip_data = null;
	
		}
		return $this->_statedata;
	}	
	
	function CityData($idxx)
	{

		// Load the data

		$query = ' SELECT city_id as ct_id , city_name as ct_name, data as ct_data'
			. ' FROM #__city'
			. ' where state_id='.$idxx
			
			.' ORDER BY city_id';
		
		//die();
			
			$this->_db->setQuery( $query );
			$this->_citydata = $this->_db->loadObjectlist();


		return $this->_citydata;
	}	
	
	
	
	function getState($country_id)
	{
		
		$query = ' SELECT  * FROM #__state '.
					'  WHERE country_id = '.$country_id;
		$db = &JFactory::getDBO();
		$db->setQuery($query);
		$result = $db->loadObjectList();					

		return $result;
	}	
	
	function getCity($state_id)
	{
		
		$query = ' SELECT * FROM #__city '.
					'  WHERE state_id = '.$state_id;
					
	
					
		$db = &JFactory::getDBO();
		$db->setQuery($query);
		$result = $db->loadObjectList();					

		return $result;
	}	
	function CheckCountryData($county_id)
	{
		// Load the data
		 $query = ' SELECT *'
			. ' FROM #__sitelocator'
			.' where country_id='.$county_id .' AND published=1' ;
			
			$this->_db->setQuery( $query );
			$countlist = $this->_db->loadRowList();
 
		return $countlist;
	}		
    function CheckStateData($st_id)
	{
		// Load the data
		$statequery = ' SELECT *'
			. ' FROM #__sitelocator'
			.' where state_id='.$st_id .' AND published=1' ;
			
			$this->_db->setQuery( $statequery );
			$statecountlist = $this->_db->loadRowList();

		return $statecountlist;
	}	
		
   function CheckCityData($ct_id)
	{
		// Load the data
		$cityquery = ' SELECT *'
			. ' FROM #__sitelocator'
			.' where city_id='.$ct_id .' AND published=1' ;
			
			$this->_db->setQuery( $cityquery );
			$citycountlist = $this->_db->loadRowList();

		return $citycountlist;
	}		
	
	/**
	 * Method to sitee a record
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function store()
	{	

		$row =& $this->getTable();
		$data = JRequest::get( 'post' );
	

		// Bind the form fields to the category table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Make sure the category record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $row->getErrorMsg() );
			return false;
		}
			
		/////// update svg file
		$this->CreateSVGContent();
		//////////////////////
		$this->LoadCountrySVGContent();
		$this->LoadCitySVGContent();
		return true;
	}

	/**
	 * Method to delete record(s)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		$row =& $this->getTable();

		if (count( $cids )) {
			foreach($cids as $cid) {
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}
			}
		}
		$this->CreateSVGContent();
		$this->LoadCountrySVGContent();
		$this->LoadCitySVGContent();
		return true;
	}
	
	function CreateSVGContent()
	
{

    


		$file_path=JPATH_SITE.DS.'components'.DS.'com_maplocator'.DS.'src';
		
		$svgFile = $file_path.DS."world.svg";
		$fh = fopen($svgFile, 'w') or die("can't open file");
		$stringData = $this->LoadWorldSVGContent();
		fwrite($fh, $stringData);
		fclose($fh);
					
		
}
 
 
function LoadWorldSVGContent()
{

    $countryparams = &JComponentHelper::getParams( 'com_maplocator' );
    $countryborder_color= $countryparams->get( 'countryborder_color' );
    $countryhighlight_color= $countryparams->get( 'countryhighlight_color' );
    $countrybackground_color= $countryparams->get( 'countrybackground_color' );
	$countryarea_background_color= $countryparams->get('countryarea_background_color' );
    $countrymap_width= $countryparams->get( 'countrymap_width' );
    $countrymap_height= $countryparams->get( 'countrymap_height' );

	
	$site_data=$this->CountryData();
	
	$fill_content="";
	$script_content="";
	
	$i=0;
	foreach ($site_data as $key => $value)	{
	$i++;

		$check_country_data=$this->CheckCountryData($value->county_id);
		
		if(count($check_country_data)>0)
		{
		
				$fill_link 		= JRoute::_( JURI::root().'index.php?option=com_maplocator&view=country&cid='. $value->county_id );
				$fill_content.=str_replace("{fill}","$countryhighlight_color",$value->county_data);
				$script_content.="var circle".$i." = document.getElementById('".trim($value->county_name)."');
								circle".$i.".addEventListener('mousedown', function(evt) {
								window.open('".$fill_link."', '_parent');
								}, false);";
		}
		else
		{
			$fill_content.=str_replace("{fill}","$countryarea_background_color", $value->county_data);
		}
	}	

	$content="";

	///svg start here
  $content.='<?xml version="1.0" ?>
<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" width="' .$countrymap_width.'" height="'.$countrymap_height.'" viewBox="82.992 45.607 2528.5721 1428.3294"      
    style="background-color: '.$countrybackground_color.'" onload="loaded(); Init(evt);">';
	 
  ////script start here	 
  $content.='<script type="text/javascript"><![CDATA[
  
var SVGDocument = null;
      var SVGRoot = null;
      var SVGViewBox = null;
      var svgns = \'http://www.w3.org/2000/svg\';
      var xlinkns = \'http://www.w3.org/1999/xlink\';
      var toolTip = null;
      var TrueCoords = null;
      var tipBox = null;
      var tipText = null;
      var tipTitle = null;
      var tipDesc = null;

      var lastElement = null;
      var titleText = \'\';
      var titleDesc = \'\';


      function Init(evt)
      {
         SVGDocument = evt.target.ownerDocument;
         SVGRoot = SVGDocument.documentElement;
         TrueCoords = SVGRoot.createSVGPoint();

         toolTip = SVGDocument.getElementById(\'ToolTip\');
         tipBox = SVGDocument.getElementById(\'tipbox\');
         tipText = SVGDocument.getElementById(\'tipText\');
         tipTitle = SVGDocument.getElementById(\'tipTitle\');
         tipDesc = SVGDocument.getElementById(\'tipDesc\');

         SVGRoot.addEventListener(\'mousemove\', ShowTooltip, false);
         SVGRoot.addEventListener(\'mouseout\', HideTooltip, false);
      };


      function GetTrueCoords(evt)
      {
         var newScale = SVGRoot.currentScale;
         var translation = SVGRoot.currentTranslate;
         TrueCoords.x = (evt.clientX - translation.x)/newScale * 10;
         TrueCoords.y = (evt.clientY - translation.y)/newScale * 10;
      };


      function HideTooltip( evt )
      {
         toolTip.setAttributeNS(null, \'visibility\', \'hidden\');
      };


      function ShowTooltip( evt )
      {
         GetTrueCoords( evt );

         var tipScale = 1/SVGRoot.currentScale;
         var textWidth = 0;
         var tspanWidth = 0;
         var boxHeight = 0;

         tipBox.setAttributeNS(null, \'transform\', \'scale(\' + tipScale + \',\' + tipScale + \')\' );
         tipText.setAttributeNS(null, \'transform\', \'scale(\' + tipScale + \',\' + tipScale + \')\' );

		 var fillValue = \'\';
         var titleValue = \'\';
         var descValue = \'\';
         var targetElement = evt.target;
         if ( lastElement != targetElement )
         {
		 
            var targetTitle = targetElement.getElementsByTagName(\'title\').item(0);

		    if ( targetTitle )
            {		   
       
               titleValue = targetTitle.firstChild.nodeValue;
            }

            var targetDesc = targetElement.getElementsByTagName(\'desc\').item(0);
            if ( targetDesc )
            {
     
               descValue = targetDesc.firstChild.nodeValue;

               if ( \'\' == titleValue )
               {
            
                  titleValue = descValue;
                  descValue = \'\';
               }
            }

  
            if ( \'\' == titleValue )
            {
              titleValue = targetElement.getAttributeNS(null, \'id\');
			   fillValue = targetElement.getAttributeNS(null, \'fill\');
			    coordinate = targetElement.getAttributeNS(null, \'d\');
		       var coordinate1 = new String(coordinate.split(\' \', 2));
		       var coordinate2 = new String(coordinate1.substr(2));
			    
            }


            var titleDisplay = \'none\';
            if ( \'\' != titleValue && fillValue=="#AE510D"  && isNaN(titleValue) )
            {
				  tipTitle.firstChild.nodeValue = titleValue;
				  titleDisplay = \'inline\';
				  tipTitle.setAttributeNS(null, \'display\', titleDisplay );
            }

         }

      
         if ( \'\' != titleValue && fillValue=="#AE510D"  && isNaN(titleValue) )
         {
            var xPos = TrueCoords.x + (10 * tipScale);
            var yPos = TrueCoords.y + (10 * tipScale);

            //return rectangle around text as SVGRect object
            var outline = tipText.getBBox();
            tipBox.setAttributeNS(null, \'width\', Number(outline.width) + 150);
            tipBox.setAttributeNS(null, \'height\', Number(outline.height) + 100);
			
		if(coordinate2)
		toolTip.setAttributeNS(null, \'transform\', \'translate(\' + coordinate2 + \')\');
	    else
		toolTip.setAttributeNS(null, \'transform\', \'translate(\' + xPos + \',\' + yPos + \')\');			


            //toolTip.setAttributeNS(null, \'transform\', \'translate(\' + xPos + \',\' + yPos + \')\');
            toolTip.setAttributeNS(null, \'visibility\', \'visible\');
         }
		 
      };
  
    
  
  
      function loaded() {

        var onloadFunc = doload;
        
        if (top.svgweb) {
          top.svgweb.addOnLoad(onloadFunc, true, window);
        } else {
          onloadFunc();
        }
      }  
	  
     function doload() {';

		$content.=$script_content;
     
	 $content.='}
  ]]></script>
  <style id="style_css_sheet" type="text/css"> 
/*
 * Below are Cascading Style Sheet (CSS) definitions in use in this file,
 * which allow easily changing how countries are displayed.
 *
 */

/*
 * Circles around small countries
 *
 * Change opacity to 1 to display all circles.
 *
 */
.circlexx
{
   opacity:0;
   fill:#ff0000;
   stroke:#ff0000;;
   stroke-width:0.5;
}

/*
 * Smaller circles around French DOMs and Chinese SARs
 *
 * Change opacity to 1 to display all subnational circles.
 *
 */

.subxx
{
   opacity:0;
   stroke-width:0.3;
}

/*
 * Circles around small, unrecognized countries
 *
 * Change opacity to 1 to display all circles.
 *
 */
.unxx
{
   opacity:0;
   fill:#e0e0e0;
   stroke:#000000;
   stroke-width:0.3;
}

/*
 * Circles around small countries, but with no permanent residents 
 *
 * Change opacity to 1 to display all circles.
 *
 */
.noxx
{
   opacity:0;
   fill:#e0e0e0;
   stroke:#000000;
   stroke-width:0.5;
}

/*
 * land
 */
.landxx
{
   
   stroke:'.$countryborder_color.'; 
   stroke-width:0.7;
   fill-rule:evenodd;
}

/*
 * Styles for coastlines of islands with no borders
 */
.coastxx
{
   fill: #e0e0e0;
   stroke:#ffffff;
   stroke-width:0.3;
   fill-rule:evenodd;
}

/*
 * Styles for nations with limited recognition
 */
.limitxx
{
   fill: #e0e0e0;
   stroke:#ffffff;
   stroke-width:0;
   fill-rule:evenodd;
}

/*
 * Styles for nations with no permanent population.
 */
.antxx
{
   fill: #e0e0e0;
   stroke:#ffffff;
   stroke-width:0;
   fill-rule:evenodd;
}

/*
 * Ocean
 */
.oceanxx
{
   opacity: 1;
   color: #000000;
   fill:#ffffff;
   stroke:#000;
   stroke-width:0.5;
   stroke-miterlimit:1;
}

/*
 * Additional style rules
 *
 * The following are examples of colouring countries.  You can substitute these with your own styles to colour the countries on the map.
 *
 * Color a few countries:
 *
 * .gb, .au, .nc
 * {
 *    fill:       #ff0000;
 * }
 *
 * Color a few small country circles (and the countries):
 *
 * .ms, .ky
 * {
 *    opacity:    1;
 *    fill:       #ff0000;
 * }
 *
 */

</style>';
  

  ////top content start here
 
  $content.='

<path class="oceanxx" d="M 2079.5058,1457.5605 L 615.24779,1457.5605 C 615.13079,1457.5605 615.07079,1457.5535 614.95179,1457.5215 C 611.67679,1456.6515 608.40179,1455.7815 605.12779,1454.9105 C 599.15079,1453.3225 593.22879,1451.5225 587.30779,1449.7385 C 564.39379,1442.8315 541.76579,1434.6995 519.46979,1426.0115 C 495.81079,1416.7935 472.34979,1407.0946 449.19179,1396.6816 C 426.78379,1386.6056 405.17679,1375.0536 383.76379,1363.0356 C 363.11779,1351.4496 343.01079,1338.8296 323.37979,1325.5996 C 302.29179,1311.3876 281.47879,1296.8506 261.05379,1281.7006 C 242.35079,1267.8276 223.73679,1253.6306 206.05279,1238.4686 C 186.98679,1222.1216 167.82379,1205.7706 150.35279,1187.6906 C 132.97779,1169.7106 116.33279,1151.0606 100.15679,1131.9976 C 84.352777,1113.3736 70.086776,1093.4716 56.901786,1072.9246 C 44.046786,1052.8916 32.093776,1032.1356 22.469776,1010.3426 C 17.516776,999.12756 12.408776,987.76556 8.7017761,976.06056 C 5.0657761,964.58166 1.5997761,953.04259 -1.5932239,941.43054 C -8.0102239,918.09356 -14.055224,894.78356 -18.234224,870.92056 C -22.491222,846.60856 -24.894222,822.19856 -26.943222,797.62156 C -28.947222,773.58556 -28.829222,749.40156 -27.225222,725.34856 C -25.648222,701.69856 -23.363222,677.92456 -19.274222,654.56456 C -15.018224,630.25156 -9.3842239,606.45156 -2.8412239,582.66156 C 3.5687761,559.35256 10.483776,536.34856 20.265776,514.19856 C 30.320776,491.42956 42.318786,469.90956 55.502786,448.81656 C 68.512776,428.00356 83.108777,408.26756 98.686787,389.31756 C 113.73479,371.01156 129.68979,353.25256 146.15179,336.20856 C 163.77479,317.96256 182.64579,301.14556 201.89579,284.64756 C 220.33379,268.84456 239.55379,253.98456 258.95979,239.39656 C 278.42779,224.76056 298.39379,210.83356 318.55579,197.17556 C 339.26979,183.14456 360.47879,169.92056 382.15079,157.42556 C 403.46579,145.13656 425.31479,133.98856 447.60479,123.59356 C 469.58579,113.34356 492.14979,104.17656 514.74579,95.375565 C 537.44879,86.532565 560.37879,78.195565 583.63479,70.914565 C 589.69379,69.017565 595.80079,67.276565 601.90879,65.549565 C 604.63079,64.779565 607.36079,64.045565 610.09479,63.318565 C 611.59979,62.918565 613.56579,61.986565 615.13379,61.986565 L 2079.9638,61.986565 C 2079.9798,61.986565 2079.9958,61.986565 2080.0118,61.986565 C 2079.8448,61.986565 2079.6788,61.986565 2079.5118,61.986565 C 2102.8268,68.191565 2125.8778,75.323565 2148.5448,83.611565 C 2171.6378,92.054565 2194.6158,100.87956 2217.2348,110.52956 C 2240.5208,120.46556 2263.4848,130.95256 2285.8828,142.76456 C 2306.9808,153.89056 2327.8178,165.78556 2347.8608,178.72156 C 2368.9418,192.32656 2389.7498,206.29256 2410.2218,220.80056 C 2429.7368,234.62956 2448.9938,248.98756 2467.6208,263.99256 C 2486.8818,279.50856 2506.0408,295.30556 2524.0538,312.27356 C 2541.8708,329.05756 2558.7508,346.67256 2574.9408,365.03656 C 2591.2478,383.53256 2607.1478,402.30656 2621.4508,422.41856 C 2635.3488,441.96256 2648.4468,462.42756 2659.5898,483.67756 C 2671.1238,505.67356 2681.1048,528.35656 2688.6188,552.05056 C 2692.2518,563.50656 2695.3368,575.14756 2698.5608,586.72256 C 2701.7738,598.25356 2704.9238,609.81956 2707.4578,621.52456 C 2712.6258,645.40556 2716.6718,669.47856 2719.1178,693.79656 C 2721.5718,718.19256 2723.1798,742.56356 2722.9808,767.09056 C 2722.7908,790.65456 2720.6908,814.43756 2717.7688,837.81156 C 2714.7368,862.07056 2710.5198,886.16156 2704.6398,909.90056 C 2701.6808,921.84356 2698.3948,933.69556 2695.0378,945.53154 C 2691.7468,957.13466 2688.5558,968.83466 2684.3988,980.16156 C 2676.0918,1002.8036 2666.1688,1024.8836 2654.1338,1045.8046 C 2641.9958,1066.9066 2628.8498,1087.4866 2614.2378,1106.9696 C 2599.1658,1127.0666 2582.6678,1145.9446 2565.8948,1164.6296 C 2549.8298,1182.5266 2532.8918,1199.7316 2514.8648,1215.6616 C 2496.0788,1232.2646 2476.8978,1248.3126 2457.1558,1263.7656 C 2438.2988,1278.5276 2418.9668,1292.7306 2399.3188,1306.4206 C 2378.7018,1320.7866 2357.7538,1334.6106 2336.4758,1347.9776 C 2326.4088,1354.3016 2316.0058,1360.1326 2305.6418,1365.9516 C 2295.0348,1371.9086 2284.3858,1378.0166 2273.4448,1383.3436 C 2250.7338,1394.3986 2227.7768,1404.7266 2204.3888,1414.2665 C 2181.7848,1423.4875 2159.0678,1432.2695 2136.0228,1440.3345 C 2117.4118,1446.8465 2098.5568,1452.4975 2079.5058,1457.5605" id="ocean"/>';
 $content.=$fill_content;
 $content.='
<g stroke="#514221" fill="none" stroke-linejoin="round" stroke-width="100">
<use xlink:href="#state_outline" fill="#A18244" stroke-width="237" />
<use xlink:href="#1294" fill="#a0a0ff" stroke="none" />';



////End SVG here  
$content.='</g><g id=\'ToolTip\' opacity=\'0.8\' visibility=\'hidden\' pointer-events=\'none\'>
      <rect id=\'tipbox\' x=\'150\' y=\'-110\' width=\'2\' height=\'2\' rx=\'20\' ry=\'20\' fill=\'white\' stroke=\'black\' stroke-width=\'20\' line-spacing=\'200\'  />
      <text id=\'tipText\'  font-size=\'80\'>
         <tspan id=\'tipTitle\' x=\'200\' font-weight=\'bold\'><![CDATA[]]></tspan>

      </text>
   </g></svg>';

return $content;

} 


/////////////////////////  country //////////////////////////
function LoadCountrySVGContent()
{
	
	$params = &JComponentHelper::getParams( 'com_maplocator' );
    $border_color= $params->get( 'border_color' );
    $highlight_color= $params->get( 'highlight_color' );
    $background_color= $params->get( 'background_color' );
	$area_background_color= $params->get('area_background_color' );
    $map_width= $params->get( 'map_width' );
    $map_height= $params->get( 'map_height' );
	
	$country_data=$this->CountryData();
	  
	
	
	

	foreach ($country_data as $country_key => $country_value)	{
	
	

		$check_country=$this->CheckCountryData($country_value->county_id);
		
		if(count($check_country)>0)
		
		{
		
		$file_path=JPATH_SITE.DS.'components'.DS.'com_maplocator'.DS.'src'.DS.'country';
		$abc=$country_value->county_name;
		
		$svgFile = $file_path.DS.$abc.'.svg';
		
		$fh = fopen($svgFile, 'w') or die("can't open file");
		
		
		
   $state_data=$this->StateData();
	
	$fill_content="";
	$script_content="";
	$ii=0;
	foreach ($state_data as $key => $value)	{
	$ii++;

		$check_state_data=$this->CheckStateData($value->st_id);
		
		if(count($check_state_data)>0)
		{
		
		
		
				$fill_link 		= JRoute::_( JURI::root().'index.php?option=com_maplocator&view=state&cid='. $value->st_id );
				$fill_content.=str_replace("{fill}","$highlight_color",$value->st_data);
			 	$script_content.="var circle".$ii." = document.getElementById('".trim($value->st_name)."');
								circle".$ii.".addEventListener('mousedown', function(evt) {
								window.open('".$fill_link."', '_parent');
								}, false);"; 
		}
		else
		{
			 $fill_content.=str_replace("{fill}","$area_background_color", $value->st_data); 
		}
		}

 $content="";
	
	///svg start here
  $content.='<?xml version="1.0" ?>
<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" width="' .$map_width.'" height="'.$map_height.'" viewBox="1 1 286 186" style="background-color: '.$background_color.'" onload="loaded(); Init(evt);">';  
     
	
  ////script start here	 
  $content.='<script type="text/javascript"><![CDATA[
  
var SVGDocument = null;
      var SVGRoot = null;
      var SVGViewBox = null;
      var svgns = \'http://www.w3.org/2000/svg\';
      var xlinkns = \'http://www.w3.org/1999/xlink\';
      var toolTip = null;
      var TrueCoords = null;
      var tipBox = null;
      var tipText = null;
      var tipTitle = null;
      var tipDesc = null;

      var lastElement = null;
      var titleText = \'\';
      var titleDesc = \'\';


      function Init(evt)
      {
         SVGDocument = evt.target.ownerDocument;
         SVGRoot = SVGDocument.documentElement;
         TrueCoords = SVGRoot.createSVGPoint();

         toolTip = SVGDocument.getElementById(\'ToolTip\');
         tipBox = SVGDocument.getElementById(\'tipbox\');
         tipText = SVGDocument.getElementById(\'tipText\');
         tipTitle = SVGDocument.getElementById(\'tipTitle\');
         tipDesc = SVGDocument.getElementById(\'tipDesc\');

         SVGRoot.addEventListener(\'mousemove\', ShowTooltip, false);
         SVGRoot.addEventListener(\'mouseout\', HideTooltip, false);
      };


      function GetTrueCoords(evt)
      {
         var newScale = SVGRoot.currentScale;
         var translation = SVGRoot.currentTranslate;
         TrueCoords.x = (evt.clientX - translation.x)/newScale * 10;
         TrueCoords.y = (evt.clientY - translation.y)/newScale * 10;
      };


      function HideTooltip( evt )
      {
         toolTip.setAttributeNS(null, \'visibility\', \'hidden\');
      };


      function ShowTooltip( evt )
      {
	
         GetTrueCoords( evt );

         var tipScale = 1/SVGRoot.currentScale;
         var textWidth = 0;
         var tspanWidth = 0;
         var boxHeight = 0;

         tipBox.setAttributeNS(null, \'transform\', \'scale(\' + tipScale + \',\' + tipScale + \')\' );
         tipText.setAttributeNS(null, \'transform\', \'scale(\' + tipScale + \',\' + tipScale + \')\' );

		 var fillValue = \'\';
         var titleValue = \'\';
         var descValue = \'\';
         var targetElement = evt.target;
         if ( lastElement != targetElement )
         {
		 
            var targetTitle = targetElement.getElementsByTagName(\'title\').item(0);

		    if ( targetTitle )
            {		   
       
               titleValue = targetTitle.firstChild.nodeValue;
            }

            var targetDesc = targetElement.getElementsByTagName(\'desc\').item(0);
            if ( targetDesc )
            {
     
               descValue = targetDesc.firstChild.nodeValue;

               if ( \'\' == titleValue )
               {
            
                  titleValue = descValue;
                  descValue = \'\';
               }
            }

  
            if ( \'\' == titleValue )
            {
               titleValue = targetElement.getAttributeNS(null, \'id\');
			   fillValue = targetElement.getAttributeNS(null, \'fill\');
			    coordinate = targetElement.getAttributeNS(null, \'d\');
		       var coordinate1 = new String(coordinate.split(\' \', 2));
		       var coordinate2 = new String(coordinate1.substr(2));
            }


            var titleDisplay = \'none\';
            if ( \'\' != titleValue && fillValue=="#AE510D"  && isNaN(titleValue) )
            {
				  tipTitle.firstChild.nodeValue = titleValue;
				  titleDisplay = \'inline\';
				  tipTitle.setAttributeNS(null, \'display\', titleDisplay );
            }

         }

      
         if ( \'\' != titleValue && fillValue=="#AE510D"  && isNaN(titleValue) )
         {
            var xPos = TrueCoords.x + (10 * tipScale);
            var yPos = TrueCoords.y + (10 * tipScale);

            //return rectangle around text as SVGRect object
            var outline = tipText.getBBox();
            tipBox.setAttributeNS(null, \'width\', Number(outline.width) + 20);
            tipBox.setAttributeNS(null, \'height\', Number(outline.height) + 10);
			
		if(coordinate2)
		{
		toolTip.setAttributeNS(null, \'transform\', \'translate(\' + coordinate2 + \')\');
	 }   else{
			toolTip.setAttributeNS(null, \'transform\', \'translate(\' + xPos + \',\' + yPos + \')\');	

}
            //toolTip.setAttributeNS(null, \'transform\', \'translate(\' + xPos + \',\' + yPos + \')\');
            toolTip.setAttributeNS(null, \'visibility\', \'visible\');
         }
		 
      };
  
    
  
  
      function loaded() {

        var onloadFunc = doload;
        
        if (top.svgweb) {
          top.svgweb.addOnLoad(onloadFunc, true, window);
        } else {
          onloadFunc();
        }
      }  
	  
     function doload() {';

		$content.=$script_content;
     
	 $content.='}
  ]]></script>';
  
  ////top content start here
  $content.=$fill_content;

  $content.='


<g id=\'ToolTip\' opacity=\'0.8\' visibility=\'hidden\' pointer-events=\'none\'>
      <rect id=\'tipbox\' x=\'10\' y=\'-17\' width=\'1\' height=\'2\' rx=\'10\' ry=\'10\' fill=\'white\' stroke=\'black\' stroke-width=\'3\' line-spacing=\'3\'  />
      <text id=\'tipText\' >
         <tspan id=\'tipTitle\' x=\'20\'  font-weight=\'bold\'><![CDATA[]]></tspan>

      </text>
   </g></svg>';

$countrystringData = $content;
		
		fwrite($fh, $countrystringData);
		fclose($fh);	


 }	
}
 
	}
 
 /// City /////////
 
  function LoadCitySVGContent()
{
	
	
	$cityparams = &JComponentHelper::getParams( 'com_maplocator' );
    $cityborder_color= $cityparams->get( 'cityborder_color' );
    $cityhighlight_color= $cityparams->get( 'cityhighlight_color' );
    $citybackground_color= $cityparams->get( 'citybackground_color' );
	$cityarea_background_color= $cityparams->get('cityarea_background_color' );
    $citymap_width= $cityparams->get( 'citymap_width' );
    $citymap_height= $cityparams->get( 'citymap_height' );
	
	
       
	$stt_data=$this->StateData();
	
	foreach ($stt_data as $stt_key => $stt_value)	{
	
	 $check_stt=$this->CheckStateData($stt_value->st_id);
		
		if(count($check_stt)>0)
		
		{

		$fill_content="";
		$script_content="";
		$abcc="";
		$clip="";
		$svgFile="";
		$citty_data="";
		
		
		$file_path=JPATH_SITE.DS.'components'.DS.'com_maplocator'.DS.'src'.DS.'state';
		$abcc=$stt_value->st_name;
		$clip=$stt_value->clip_data;
		
		$svgFile = $file_path.DS.$abcc.'.svg';
		
		$fh = fopen($svgFile, 'w') or die("can't open file");
		
		
		$citty_data=$this->CityData($stt_value->st_id);
	
        /*
		if($stt_value->st_id=="23")
		{
			echo $stt_value->st_id;
			
			echo "<pre>";
			print_r($citty_data);	
			
			echo "--------------------->";
			die();	
		}
		*/
		
		
	$x=0;
	foreach ($citty_data as $keyy => $valuee)	{
	$x++;

		$check_city_data=$this->CheckCityData($valuee->ct_id);
		
		if(count($check_city_data)>0)
		{
				$fill_link 		= JRoute::_( JURI::root().'index.php?option=com_maplocator&view=sites&cid='. $valuee->ct_id );
				$fill_content.=str_replace("{fill}","$cityhighlight_color",$valuee->ct_data);
				$script_content.="var circle".$x." = document.getElementById('".trim($valuee->ct_name)."');
								circle".$x.".addEventListener('mousedown', function(evt) {
								window.open('".$fill_link."', '_parent');
								}, false);";
		}
		else
		{
			$fill_content.=str_replace("{fill}","$cityarea_background_color", $valuee->ct_data);
		}
	}

	$content="";
	
	///svg start here
  $content.='<?xml version="1.0" ?>
<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" width="' .$citymap_width.'" height="'.$citymap_height.'"  viewBox="-17394,-23315 33786,53462"  style="background-color: '.$citybackground_color.'"      
     onload="loaded(); Init(evt);">';
	 
  ////script start here	 
  $content.='<script type="text/javascript"><![CDATA[
  
var SVGDocument = null;
      var SVGRoot = null;
      var SVGViewBox = null;
      var svgns = \'http://www.w3.org/2000/svg\';
      var xlinkns = \'http://www.w3.org/1999/xlink\';
      var toolTip = null;
      var TrueCoords = null;
      var tipBox = null;
      var tipText = null;
      var tipTitle = null;
      var tipDesc = null;

      var lastElement = null;
      var titleText = \'\';
      var titleDesc = \'\';


      function Init(evt)
      {
         SVGDocument = evt.target.ownerDocument;
         SVGRoot = SVGDocument.documentElement;
         TrueCoords = SVGRoot.createSVGPoint();

         toolTip = SVGDocument.getElementById(\'ToolTip\');
         tipBox = SVGDocument.getElementById(\'tipbox\');
         tipText = SVGDocument.getElementById(\'tipText\');
         tipTitle = SVGDocument.getElementById(\'tipTitle\');
         tipDesc = SVGDocument.getElementById(\'tipDesc\');

         SVGRoot.addEventListener(\'mousemove\', ShowTooltip, false);
         SVGRoot.addEventListener(\'mouseout\', HideTooltip, false);
      };


      function GetTrueCoords(evt)
      {
         var newScale = SVGRoot.currentScale;
         var translation = SVGRoot.currentTranslate;
         TrueCoords.x = (evt.clientX - translation.x)/newScale * 10;
         TrueCoords.y = (evt.clientY - translation.y)/newScale * 10;
      };


      function HideTooltip( evt )
      {
         toolTip.setAttributeNS(null, \'visibility\', \'hidden\');
      };


      function ShowTooltip( evt )
      {
	
         GetTrueCoords( evt );

         var tipScale = 1/SVGRoot.currentScale;
         var textWidth = 0;
         var tspanWidth = 0;
         var boxHeight = 0;

         tipBox.setAttributeNS(null, \'transform\', \'scale(\' + tipScale + \',\' + tipScale + \')\' );
         tipText.setAttributeNS(null, \'transform\', \'scale(\' + tipScale + \',\' + tipScale + \')\' );

		 var fillValue = \'\';
         var titleValue = \'\';
         var descValue = \'\';
         var targetElement = evt.target;
         if ( lastElement != targetElement )
         {
            var targetTitle = targetElement.getElementsByTagName(\'title\').item(0);

		    if ( targetTitle )
            {		   
       
               titleValue = targetTitle.firstChild.nodeValue;
            }

            var targetDesc = targetElement.getElementsByTagName(\'desc\').item(0);
            if ( targetDesc )
            {
     
               descValue = targetDesc.firstChild.nodeValue;

               if ( \'\' == titleValue )
               {
            
                  titleValue = descValue;
                  descValue = \'\';
               }
            }

  
            if ( \'\' == titleValue )
            {
               titleValue = targetElement.getAttributeNS(null, \'id\');
			   fillValue = targetElement.getAttributeNS(null, \'fill\');
			    coordinate = targetElement.getAttributeNS(null, \'d\');
		       var coordinate1 = new String(coordinate.split(\' \', 2));
		       var coordinate2 = new String(coordinate1.substr(2));
            }


            var titleDisplay = \'none\';
            if ( \'\' != titleValue && fillValue=="#AE510D"  && isNaN(titleValue) )
            {
				  tipTitle.firstChild.nodeValue = titleValue;
				  titleDisplay = \'inline\';
				  tipTitle.setAttributeNS(null, \'display\', titleDisplay );
            }

         }

      
         if ( \'\' != titleValue && fillValue=="#AE510D"  && isNaN(titleValue) )
         {
            var xPos = TrueCoords.x + (10 * tipScale);
            var yPos = TrueCoords.y + (10 * tipScale);

            //return rectangle around text as SVGRect object
            var outline = tipText.getBBox();
            tipBox.setAttributeNS(null, \'width\', Number(outline.width) + 1000);
            tipBox.setAttributeNS(null, \'height\', Number(outline.height) + 1000);
			
		if(coordinate2)
		toolTip.setAttributeNS(null, \'transform\', \'translate(\' + coordinate2 + \')\');
	    else
		toolTip.setAttributeNS(null, \'transform\', \'translate(\' + xPos + \',\' + yPos + \')\');			


            //toolTip.setAttributeNS(null, \'transform\', \'translate(\' + xPos + \',\' + yPos + \')\');
            toolTip.setAttributeNS(null, \'visibility\', \'visible\');
         }
		 
      };
  
    
  
  
      function loaded() {

        var onloadFunc = doload;
        
        if (top.svgweb) {
          top.svgweb.addOnLoad(onloadFunc, true, window);
        } else {
          onloadFunc();
        }
      }  
	  
     function doload() {';

		$content.=$script_content;
     
	 $content.='}
  ]]></script>';
  
  ////top content start here
  
  $content.='<clipPath id="state_clip_path">

   '.$clip.'
 </clipPath>

<g stroke="'.$cityborder_color.'" fill="none" stroke-linejoin="round" stroke-width="54">
<use xlink:href="#state_outline" fill="#A18244" stroke-width="236" />';

$content.=$fill_content;

////End SVG here  
$content.='</g><g id=\'ToolTip\' opacity=\'0.8\' visibility=\'hidden\' pointer-events=\'none\'>
      <rect id=\'tipbox\' x=\'-700\' y=\'5\' width=\'8\' height=\'20\' rx=\'800\' ry=\'800\' fill=\'white\' stroke=\'black\' stroke-width=\'200\' line-spacing=\'200\'  />
      <text id=\'tipText\' x=\'2225\' y=\'2888\' font-family=\'Trebuchet MS\' font-size=\'2222\'>
         <tspan id=\'tipTitle\' x=\'5\' font-weight=\'bold\'><![CDATA[]]></tspan>

      </text>
   </g></svg>';


        $sttstringData =$content;
		fwrite($fh, $sttstringData);
		fclose($fh);	
		
}

 }	
 
 	
 $sttstringData="";
  $content="";
  $fill_content="";
 
//exit;

}


 
	}

?>